/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2020 Realtek Technologies Co., Ltd
 */

#ifndef RTL_TYPES_H
#define RTL_TYPES_H

#include <stdint.h>
#include <stddef.h>
#include <inttypes.h>
#include <string.h>
#include <rte_common.h>
#include <rte_cycles.h>
#include <rte_log.h>
#include <rte_debug.h>
#include <rte_byteorder.h>
#include <rte_io.h>

typedef uint8_t		u8;
typedef int8_t		s8;
typedef uint16_t	u16;
typedef int16_t		s16;
typedef uint32_t	u32;
typedef int32_t		s32;
typedef uint64_t	u64;

#define RTL_R32(hw, reg) \
	rtl_read32((volatile u32 *)((char *)(hw)->mmio_addr + (reg)))

static inline u32 rtl_read32(volatile void *addr)
{
        return rte_le_to_cpu_32(rte_read32(addr));
}

#endif
